/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.records.TCoreUmlsRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreUmls extends TableImpl<TCoreUmlsRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_umls</code>
     */
    public static final TCoreUmls T_CORE_UMLS = new TCoreUmls();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreUmlsRecord> getRecordType() {
        return TCoreUmlsRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_umls.lastchange</code>.
     */
    public final TableField<TCoreUmlsRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_umls.pk</code>. unique id
     */
    public final TableField<TCoreUmlsRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "unique id");

    /**
     * The column <code>common_dd.t_core_umls.dn</code>. reference to dn of
     * element
     */
    public final TableField<TCoreUmlsRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB.nullable(false), this, "reference to dn of element");

    /**
     * The column <code>common_dd.t_core_umls.umls</code>. umls code for element
     */
    public final TableField<TCoreUmlsRecord, String> UMLS = createField(DSL.name("umls"), SQLDataType.CLOB.nullable(false), this, "umls code for element");

    private TCoreUmls(Name alias, Table<TCoreUmlsRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreUmls(Name alias, Table<TCoreUmlsRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_umls</code> table reference
     */
    public TCoreUmls(String alias) {
        this(DSL.name(alias), T_CORE_UMLS);
    }

    /**
     * Create an aliased <code>common_dd.t_core_umls</code> table reference
     */
    public TCoreUmls(Name alias) {
        this(alias, T_CORE_UMLS);
    }

    /**
     * Create a <code>common_dd.t_core_umls</code> table reference
     */
    public TCoreUmls() {
        this(DSL.name("t_core_umls"), null);
    }

    public <O extends Record> TCoreUmls(Table<O> path, ForeignKey<O, TCoreUmlsRecord> childPath, InverseForeignKey<O, TCoreUmlsRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_UMLS);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreUmlsPath extends TCoreUmls implements Path<TCoreUmlsRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreUmlsPath(Table<O> path, ForeignKey<O, TCoreUmlsRecord> childPath, InverseForeignKey<O, TCoreUmlsRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreUmlsPath(Name alias, Table<TCoreUmlsRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreUmlsPath as(String alias) {
            return new TCoreUmlsPath(DSL.name(alias), this);
        }

        @Override
        public TCoreUmlsPath as(Name alias) {
            return new TCoreUmlsPath(alias, this);
        }

        @Override
        public TCoreUmlsPath as(Table<?> alias) {
            return new TCoreUmlsPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.IDX_UMLS_DN, Indexes.IDX_UMLS_UMLS);
    }

    @Override
    public Identity<TCoreUmlsRecord, Integer> getIdentity() {
        return (Identity<TCoreUmlsRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreUmlsRecord> getPrimaryKey() {
        return Keys.PK_CORE_UMLS;
    }

    @Override
    public List<UniqueKey<TCoreUmlsRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_UMLS);
    }

    @Override
    public List<ForeignKey<TCoreUmlsRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_UMLS__FK_CORE_UMLS_DN);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_CORE_UMLS__FK_CORE_UMLS_DN, null);

        return _tCoreElementHierarchy;
    }

    @Override
    public TCoreUmls as(String alias) {
        return new TCoreUmls(DSL.name(alias), this);
    }

    @Override
    public TCoreUmls as(Name alias) {
        return new TCoreUmls(alias, this);
    }

    @Override
    public TCoreUmls as(Table<?> alias) {
        return new TCoreUmls(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreUmls rename(String name) {
        return new TCoreUmls(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreUmls rename(Name name) {
        return new TCoreUmls(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreUmls rename(Table<?> name) {
        return new TCoreUmls(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUmls where(Condition condition) {
        return new TCoreUmls(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUmls where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUmls where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUmls where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUmls where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUmls where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUmls where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUmls where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUmls whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUmls whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
